;; Copyright 2009 Vitaly Mayatskikh <v.mayatskih@gmail.com>
;;
;; This file is a part of CL-Video4Linux2
;;
;; CL-Video4Linux2 is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;;
;; CL-Video4Linux2 is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.

(defpackage #:cl-v4l2
  (:nicknames :v4l2)
  (:use :cl :cffi #:trivial-garbage #:closer-mop)
  (:shadowing-import-from :closer-mop
			  :defclass
			  :defgeneric
			  :defmethod
			  :standard-generic-function)
  (:shadow :format :standard)
  (:export
   #:query-capabilities
   #:capable
   #:get-stream-params
   #:get-tuner-params
   #:get-input-params
   #:get-input-standard
   #:get-format
   #:capability-driver
   #:capability-card
   #:capability-bus
   #:capability-version
   #:%device-info
   #:device-info
   #:set-input
   #:set-image-format
   #:get-image-format
   #:request-buffers
   #:query-buffer
   #:query-buffers
   #:map-buffers
   #:unmap-buffers
   #:stream
   #:stream-on
   #:stream-off
   #:get-frame
   #:put-frame
   #:set-control
   #:get-control

   ;; structs
   #:capability
   #:fract
   #:captureparm
   #:outputparm
   #:streamparm
   #:tuner
   #:standard
   #:input
   #:fmtdesc
   #:pix-format
   #:timecode
   #:requestbuffers
   #:buffer
   #:format

   ;; constants
   #:vidioc-querycap
   #:vidioc-get-parm
   #:vidioc-get-tuner
   #:vidioc-enuminput
   #:vidioc-enumstd
   #:vidioc-enum-fmt
   #:vidioc-set-input
   #:vidioc-set-fmt
   #:vidioc-get-fmt
   #:vidioc-reqbufs
   #:vidioc-querybuf
   #:vidioc-qbuf
   #:vidioc-dqbuf
   #:vidioc-stream-on
   #:vidioc-stream-off
   #:cap-video-capture
   #:cap-video-output
   #:cap-video-overlay
   #:cap-vbi-capture
   #:cap-vbi-output
   #:cap-sliced-vbi-capture
   #:cap-sliced-vbi-output
   #:cap-rds-capture
   #:cap-video-output-overlay
   #:cap-hw-freq-seek
   #:cap-tuner
   #:cap-audio
   #:cap-radio
   #:cap-readwrite
   #:cap-asyncio
   #:cap-streaming
   #:pix-fmt-rgb332
   #:pix-fmt-rgb444
   #:pix-fmt-rgb555
   #:pix-fmt-rgb565
   #:pix-fmt-rgb555x
   #:pix-fmt-rgb565x
   #:pix-fmt-bgr24
   #:pix-fmt-rgb24
   #:pix-fmt-bgr32
   #:pix-fmt-rgb32
   #:pix-fmt-grey
   #:pix-fmt-y16
   #:pix-fmt-pal8
   #:pix-fmt-yvu410
   #:pix-fmt-yvu420
   #:pix-fmt-yuyv
   #:pix-fmt-uyvy
   #:pix-fmt-vyuy
   #:pix-fmt-yuv422p
   #:pix-fmt-yuv411p
   #:pix-fmt-y41p
   #:pix-fmt-yuv444
   #:pix-fmt-yuv555
   #:pix-fmt-yuv565
   #:pix-fmt-yuv32
   #:pix-fmt-nv12
   #:pix-fmt-nv21
   #:pix-fmt-nv16
   #:pix-fmt-nv61
   #:pix-fmt-yuv410
   #:pix-fmt-yuv420
   #:pix-fmt-yyuv
   #:pix-fmt-hi240
   #:pix-fmt-hm12
   #:pix-fmt-sbggr8
   #:pix-fmt-sgbrg8
   #:pix-fmt-sgrbg10
   #:pix-fmt-sgrbg10dpcm8
   #:pix-fmt-sbggr16
   #:pix-fmt-mjpeg
   #:pix-fmt-jpeg
   #:pix-fmt-dv
   #:pix-fmt-mpeg
   #:pix-fmt-wnva
   #:pix-fmt-sn9c10x
   #:pix-fmt-pwc1
   #:pix-fmt-pwc2
   #:pix-fmt-et61x251
   #:pix-fmt-spca501
   #:pix-fmt-spca505
   #:pix-fmt-spca508
   #:pix-fmt-spca561
   #:pix-fmt-pac207
   #:pix-fmt-mr97310a
   #:pix-fmt-sq905c
   #:pix-fmt-pjpg
   #:pix-fmt-yvyu
   #:buf-flag-mapped
   #:buf-flag-queued
   #:buf-flag-done
   #:buf-flag-keyframe
   #:buf-flag-pframe
   #:buf-flag-bframe
   #:buf-flag-timecode
   #:buf-flag-input
   #:input-type-tuner
   #:input-type-camera
   #:cid-brightness
   #:cid-contrast
   #:cid-saturation
   #:cid-hue
   #:cid-audio-volume
   #:cid-audio-balance
   #:cid-audio-bass
   #:cid-audio-treble
   #:cid-audio-mute
   #:cid-audio-loudness
   #:cid-black-level
   #:cid-auto-white-balance
   #:cid-do-white-balance
   #:cid-red-balance
   #:cid-blue-balance
   #:cid-gamma
   #:cid-whiteness
   #:cid-exposure
   #:cid-autogain
   #:cid-gain
   #:cid-hflip
   #:cid-vflip
   #:cid-hcenter
   #:cid-vcenter
   #:cid-power-line-frequency
   #:cid-hue-auto
   #:cid-white-balance-temperature
   #:cid-sharpness
   #:cid-backlight-compensation
   #:cid-chroma-agc
   #:cid-color-killer
   #:cid-colorfx
   #:cid-exposure-auto
   #:cid-exposure-absolute
   #:cid-exposure-auto-priority
   #:cid-pan-relative
   #:cid-tilt-relative
   #:cid-pan-reset
   #:cid-tilt-reset
   #:cid-pan-absolute
   #:cid-tilt-absolute
   #:cid-focus-absolute
   #:cid-focus-relative
   #:cid-focus-auto
   #:cid-zoom-absolute
   #:cid-zoom-relative
   #:cid-zoom-continuous
   #:cid-privacy

   #:capability-driver
   #:capability-card
   #:capability-bus-info
   #:capability-version
   #:capability-capabilities
   #:capability-reserved
   #:fract-numerator
   #:fract-denominator
   #:captureparm-capability
   #:captureparm-capturemode
   #:captureparm-timeperframe
   #:captureparm-extendedmode
   #:captureparm-readbuffers
   #:captureparm-reserved
   #:outputparm-capability
   #:outputparm-outputmode
   #:outputparm-timeperframe
   #:outputparm-extendedmode
   #:outputparm-writebuffers
   #:outputparm-reserved
   #:streamparm-union-capture
   #:streamparm-union-output
   #:streamparm-union-raw-data
   #:streamparm-type
   #:streamparm-parm
   #:tuner-index
   #:tuner-name
   #:tuner-type
   #:tuner-capability
   #:tuner-rangelow
   #:tuner-rangehigh
   #:tuner-rxsubchans
   #:tuner-audmode
   #:tuner-signal
   #:tuner-afc
   #:tuner-reserved
   #:standard-index
   #:standard-id
   #:standard-name
   #:standard-frameperiod
   #:standard-framelines
   #:standard-reserved
   #:input-index
   #:input-name
   #:input-type
   #:input-audioset
   #:input-tuner
   #:input-std
   #:input-status
   #:input-reserved
   #:fmtdesc-index
   #:fmtdesc-type
   #:fmtdesc-flags
   #:fmtdesc-description
   #:fmtdesc-pixelformat
   #:fmtdesc-reserved
   #:pix-format-width
   #:pix-format-height
   #:pix-format-pixelformat
   #:pix-format-field
   #:pix-format-bytesperline
   #:pix-format-sizeimage
   #:pix-format-colorspace
   #:pix-format-priv
   #:timecode-type
   #:timecode-flags
   #:timecode-frames
   #:timecode-seconds
   #:timecode-minutes
   #:timecode-hours
   #:timecode-userbits
   #:requestbuffers-count
   #:requestbuffers-type
   #:requestbuffers-memory
   #:requestbuffers-reserved
   #:buffer-union-offset
   #:buffer-union-userptr
   #:buffer-index
   #:buffer-type
   #:buffer-bytesused
   #:buffer-flags
   #:buffer-field
   #:buffer-timestamp
   #:buffer-timecode
   #:buffer-sequence
   #:buffer-memory
   #:buffer-m
   #:buffer-length
   #:buffer-input
   #:buffer-reserved
   #:queryctrl-id
   #:queryctrl-type
   #:queryctrl-name
   #:queryctrl-minimum
   #:queryctrl-maximum
   #:queryctrl-step
   #:queryctrl-default-value
   #:queryctrl-flags
   #:queryctrl-reserved
   #:control-id
   #:control-value
   #:pix-format-width
   #:pix-format-height
   #:pix-format-pixelformat
   #:pix-format-field
   #:pix-format-bytesperline
   #:pix-format-sizeimage
   #:pix-format-colorspace
   #:pix-format-priv
   #:format-type
   #:format-pix
   #:buffer-index
   #:buffer-type
   #:buffer-bytesused
   #:buffer-flags
   #:buffer-field
   #:buffer-timestamp
   #:buffer-timecode
   #:buffer-sequence
   #:buffer-memory
   #:buffer-m
   #:buffer-length
   #:buffer-input
   #:buffer-reserved

   #:afc
   #:audioset
   #:audmode
   #:bus-info
   #:bytesperline
   #:bytesused
   #:capabilities
   #:capability
   #:capture
   #:capturemode
   #:card
   #:colorspace
   #:count
   #:default-value
   #:denominator
   #:description
   #:driver
   #:extendedmode
   #:field
   #:flags
   #:framelines
   #:frameperiod
   #:frames
   #:height
   #:hours
   #:id
   #:index
   #:input
   #:length
   #:m
   #:maximum
   #:memory
   #:minimum
   #:minutes
   #:name
   #:numerator
   #:offset
   #:output
   #:outputmode
   #:parm
   #:pix
   #:pixelformat
   #:priv
   #:rangehigh
   #:rangelow
   #:raw-data
   #:readbuffers
   #:reserved
   #:rxsubchans
   #:seconds
   #:sequence
   #:signal
   #:sizeimage
   #:status
   #:std
   #:step
   #:timecode
   #:timeperframe
   #:timestamp
   #:tuner
   #:type
   #:userbits
   #:userptr
   #:value
   #:version
   #:width
   #:writebuffers))
